Index: java/main/src/main/java/com/framsticks/visualization/Viewer.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/Viewer.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/visualization/Viewer.java	(revision 84)
@@ -1,5 +1,4 @@
 package com.framsticks.visualization;
 
-import com.framsticks.model.World;
 import com.sun.j3d.loaders.IncorrectFormatException;
 import com.sun.j3d.loaders.ParsingErrorException;
@@ -13,36 +12,21 @@
 import javax.media.j3d.*;
 import javax.swing.*;
-import javax.swing.text.StyledDocument;
 import javax.vecmath.Color3f;
 import javax.vecmath.Point3d;
 import javax.vecmath.Vector3f;
 import java.awt.*;
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
-import java.io.FileNotFoundException;
+import java.io.*;
 
-import org.apache.log4j.Logger;
+// import org.apache.log4j.Logger;
 
 public class Viewer {
 
-    private static Logger LOGGER = Logger.getLogger(Viewer.class);
+    // private static Logger log = Logger.getLogger(Viewer.class);
 
     Canvas3D canvas3d;
     SimpleUniverse universe;
 
-    World world;
-    private JMenuBar menuBar;
-
-	private JScrollPane scrollPane;
-    private boolean scrollLock = false;
-
-	private JCheckBoxMenuItem loggingItem;
-    private JCheckBoxMenuItem autorefreshItem;
-
-    public Viewer(JMenuBar menuBar) {
+    public Viewer() {
         super();
-        this.menuBar = menuBar;
-        loggingItem = new JCheckBoxMenuItem("Logging");
-        loggingItem.setSelected(true);
 
         init();
@@ -66,5 +50,5 @@
         objScale.addChild(objTrans);
 
-        String filename = "/static/shared/res/obj/cylinder.obj";
+        String filename = "/visualization/models/cylinder.obj";
         int flags = ObjectFile.RESIZE;
         flags |= ObjectFile.TRIANGULATE;
@@ -75,5 +59,6 @@
         Scene s = null;
         try {
-            s = f.load(this.getClass().getResource(filename).getFile());
+			InputStream is = this.getClass().getResourceAsStream(filename);
+            s = f.load(new InputStreamReader(is));
         } catch (FileNotFoundException e) {
             System.err.println(e);
@@ -89,6 +74,5 @@
         objTrans.addChild(s.getSceneGroup());
 
-        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0),
-                100.0);
+        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
 
         Color3f bgColor = new Color3f(0.05f, 0.05f, 0.5f);
@@ -105,17 +89,5 @@
         textPane.setEditable(false);
 
-	    StyledDocument styledDocument = textPane.getStyledDocument();
-
-        scrollPane = new JScrollPane(textPane);
-        //scrollPane.
-        //scrollPane
-        //		.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
-
-        // paneScrollPane.setMinimumSize(new Dimension(400, 300));
-
-        createMenuBar();
-
-        GraphicsConfiguration config = SimpleUniverse
-                .getPreferredConfiguration();
+        GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
 
         // Create a Canvas3D using the preferred configuration
@@ -124,6 +96,5 @@
         // Create simple universe with view branch
         universe = new SimpleUniverse(canvas3d);
-        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0),
-                100.0);
+        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
 
         // add mouse behaviours to the ViewingPlatform
@@ -173,6 +144,5 @@
         // behaviour.addListener(canvas3d);
         // behaviour.initialize();
-        behaviour.setSchedulingBounds(new BoundingSphere(new Point3d(0.0, 0.0,
-                0.0), 100.0));
+        behaviour.setSchedulingBounds(new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0));
         transformGroup.addChild(content);
         // transformGroup.addChild(behaviour);
@@ -180,77 +150,8 @@
 
         universe.addBranchGraph(scene);
-
-
-    }
-
-    private void createMenuBar() {
-
-        JMenu serverItem = new JMenu("Manager");
-        menuBar.add(serverItem);
-
-        JMenuItem testModeItem = new JMenuItem("Test mode");
-        serverItem.add(testModeItem);
-
-	    JMenuItem connectItem = new JMenuItem("Connect");
-        serverItem.add(connectItem);
-
-        JMenu simulationItem = new JMenu("Simulation");
-        menuBar.add(simulationItem);
-
-	    //TODO: move init to main window
-        JMenuItem initItem = new JMenuItem("Init");
-        simulationItem.add(initItem);
-        initItem.addActionListener(new ActionListener() {
-            public void actionPerformed(ActionEvent event) {
-            }
-        });
-
-        JMenuItem refreshCreaturesItem = new JMenuItem("Refresh creatures");
-        simulationItem.add(refreshCreaturesItem);
-        refreshCreaturesItem.addActionListener(new ActionListener() {
-            public void actionPerformed(ActionEvent event) {
-
-            }
-        });
-
-        JMenuItem refreshWorldItem = new JMenuItem("Refresh world");
-        simulationItem.add(refreshWorldItem);
-        refreshWorldItem.addActionListener(new ActionListener() {
-            public void actionPerformed(ActionEvent event) {
-                refreshWorld();
-            }
-        });
-
-	    JMenu styleMenu = new JMenu("Style");
-        menuBar.add(styleMenu);
-
-	    JMenu viewMenu = new JMenu("View");
-        menuBar.add(viewMenu);
-        rebuildViewMenu(null);
-
-        JMenu optionsMenu = new JMenu("Options");
-        menuBar.add(optionsMenu);
-
-        autorefreshItem = new JCheckBoxMenuItem("Autorefresh");
-        autorefreshItem.addActionListener(new ActionListener() {
-            public void actionPerformed(ActionEvent e) {
-                if (autorefreshItem.isSelected()) {
-
-                }
-            }
-        });
-        optionsMenu.add(autorefreshItem);
-
-        optionsMenu.add(loggingItem);
-
-    }
-
-    public void refreshWorld() {
-
-
-    }
-
-    public void rebuildViewMenu(Object creatures) {
-
+		canvas3d.startRenderer();
+		Dimension d = new Dimension(500, 500);
+		canvas3d.setMinimumSize(d);
+		canvas3d.setSize(d);
     }
 
@@ -259,7 +160,4 @@
     }
 
-    public Component getControlComponent() {
-        return scrollPane;
-    }
 
 }
Index: java/main/src/main/java/com/framsticks/visualization/ViewerTest.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/ViewerTest.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/visualization/ViewerTest.java	(revision 84)
@@ -0,0 +1,134 @@
+package com.framsticks.visualization;
+
+import com.sun.j3d.utils.universe.*;
+import com.sun.j3d.utils.geometry.ColorCube;
+import org.apache.log4j.Logger;
+
+import javax.media.j3d.*;
+import javax.swing.*;
+import javax.vecmath.*;
+import java.awt.*;
+import java.awt.event.ComponentEvent;
+import java.awt.event.ComponentListener;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+@SuppressWarnings("serial")
+public class ViewerTest extends JPanel {
+	private static final Logger log = Logger.getLogger(ViewerTest.class.getName());
+
+	private SimpleUniverse univ = null;
+	private BranchGroup scene = null;
+
+	public BranchGroup createSceneGraph() {
+		// Create the root of the branch graph
+		BranchGroup objRoot = new BranchGroup();
+
+		// Create the TransformGroup node and initialize it to the
+		// identity. Enable the TRANSFORM_WRITE capability so that
+		// our behavior code can modify it at run time. Add it to
+		// the root of the subgraph.
+		TransformGroup objTrans = new TransformGroup();
+		objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
+		objRoot.addChild(objTrans);
+
+		// Create a simple Shape3D node; add it to the scene graph.
+		objTrans.addChild(new ColorCube(0.4));
+
+		// Create a new Behavior object that will perform the
+		// desired operation on the specified transform and add
+		// it into the scene graph.
+		Transform3D yAxis = new Transform3D();
+		Alpha rotationAlpha = new Alpha(-1, 4000);
+
+		RotationInterpolator rotator =
+				new RotationInterpolator(rotationAlpha, objTrans, yAxis,
+						0.0f, (float) Math.PI * 2.0f);
+		BoundingSphere bounds =
+				new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
+		rotator.setSchedulingBounds(bounds);
+		objRoot.addChild(rotator);
+
+		// Have Java 3D perform optimizations on this scene graph.
+		objRoot.compile();
+
+		return objRoot;
+	}
+
+	private Canvas3D createUniverse() {
+		// Get the preferred graphics configuration for the default screen
+		GraphicsConfiguration config =
+				SimpleUniverse.getPreferredConfiguration();
+
+		// Create a Canvas3D using the preferred configuration
+		final Canvas3D c = new Canvas3D(config) {
+			@Override
+			public void paint(Graphics graphics) {
+				super.paint(graphics);
+				Toolkit.getDefaultToolkit().sync();
+			}
+
+			@Override
+			public void postRender() {
+				super.postRender();
+				//log.info("postRender()");
+			}
+			@Override
+			public void postSwap() {
+				super.postSwap();
+				//log.info("postSwap()");
+			}
+		};
+
+
+		c.addComponentListener(new ComponentListener() {
+			@Override
+			public void componentResized(ComponentEvent componentEvent) {
+			}
+
+			@Override
+			public void componentMoved(ComponentEvent componentEvent) {
+			}
+
+			@Override
+			public void componentShown(ComponentEvent componentEvent) {
+				log.info("shown");
+				c.startRenderer();
+			}
+
+			@Override
+			public void componentHidden(ComponentEvent componentEvent) {
+				log.info("hidden");
+				c.stopRenderer();
+			}
+		});
+
+		// Create simple universe with view branch
+		univ = new SimpleUniverse(c);
+
+		// This will move the ViewPlatform back a bit so the
+		// objects in the scene can be viewed.
+		univ.getViewingPlatform().setNominalViewingTransform();
+
+		// Ensure at least 5 msec per frame (i.e., < 200Hz)
+		univ.getViewer().getView().setMinimumFrameCycleTime(16);
+
+		return c;
+	}
+
+	public ViewerTest() {
+
+		this.setLayout(new java.awt.BorderLayout());
+
+		this.setPreferredSize(new java.awt.Dimension(250, 250));
+
+		Canvas3D c = createUniverse();
+		c.setSize(100, 100);
+		this.add(c, java.awt.BorderLayout.CENTER);
+
+		// Create the content branch and add it to the universe
+		scene = createSceneGraph();
+		univ.addBranchGraph(scene);
+	}
+}
Index: java/main/src/test/java/com/framsticks/gui/BrowserTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/gui/BrowserTest.java	(revision 84)
+++ java/main/src/test/java/com/framsticks/gui/BrowserTest.java	(revision 84)
@@ -0,0 +1,114 @@
+package com.framsticks.gui;
+
+import javax.swing.JFrame;
+
+import org.apache.commons.configuration.PropertiesConfiguration;
+import org.apache.log4j.Logger;
+import org.fest.swing.edt.FailOnThreadViolationRepaintManager;
+import org.fest.swing.edt.GuiActionRunner;
+import org.fest.swing.edt.GuiQuery;
+import org.fest.swing.edt.GuiTask;
+import org.fest.swing.fixture.FrameFixture;
+import org.fest.swing.fixture.JTreeFixture;
+// import static org.fest.swing.edt.GuiActionRunner.*;
+import org.testng.annotations.*;
+
+import com.framsticks.communication.ClientConnection;
+import com.framsticks.remote.RemoteInstance;
+import com.framsticks.test.TestConfiguration;
+
+import static org.fest.assertions.Assertions.*;
+import static org.fest.swing.core.BasicRobot.robotWithNewAwtHierarchy;
+import static org.fest.swing.edt.GuiActionRunner.*;
+import org.fest.swing.core.Robot;
+
+public class BrowserTest extends TestConfiguration {
+	private static final Logger log = Logger.getLogger(BrowserTest.class);
+
+	Browser browser;
+	Robot robot;
+	FrameFixture frame;
+
+	@BeforeClass
+	public void setUp() {
+		FailOnThreadViolationRepaintManager.install();
+		assertThat(executeInEDT()).isTrue();
+
+		robot = robotWithNewAwtHierarchy();
+
+		browser = new Browser();
+		browser.configure(new PropertiesConfiguration());
+
+		RemoteInstance localhost = new RemoteInstance();
+		localhost.setName("localhost");
+		localhost.setConnection(new ClientConnection("localhost:9009"));
+
+		browser.addEndpointForInstance(localhost);
+
+		browser.start();
+		// robot.waitForIdle();
+		frame = new FrameFixture(robot,
+				GuiActionRunner.execute(new GuiQuery<JFrame>() {
+					@Override
+					protected JFrame executeInEDT() throws Throwable {
+						return browser.getMainFrame();
+					}
+				}));
+
+		log.info("frame fixture done");
+		// frame.show();
+		// log.info("frame fixture shown");
+	}
+
+	public void clickAndExpandPath(JTreeFixture tree, String path) {
+		tree.clickPath(path).expandPath(path);
+		robot.waitForIdle();
+	}
+
+	@Test
+	public void testShow() {
+		log.info("testing");
+		JTreeFixture tree = frame.tree("tree");
+		tree.clickRow(0).expandRow(0);
+		robot.waitForIdle();
+		tree.clickRow(1).expandRow(1);
+		robot.waitForIdle();
+		assertThat(tree.valueAt(1)).isEqualTo("simulator");
+		robot.waitForIdle();
+		execute(new GuiTask() {
+			@Override
+			protected void executeInEDT() throws Throwable {
+				assertThat(frame.panel("o Simulator").component().isVisible())
+						.isTrue();
+			}
+		});
+
+		clickAndExpandPath(tree, "localhost/simulator/genepools");
+		clickAndExpandPath(tree, "localhost/simulator/genepools/groups");
+		clickAndExpandPath(tree, "localhost/simulator/genepools/groups/Genotypes");
+		// tree.clickPath("localhost/simulator/genepools/groups/Genotypes/genotypes");
+		// robot.waitForIdle();
+		// sleep(2);
+		// tree.expandPath("localhost/simulator/genepools/groups/Genotypes/genotypes");
+
+		// tree.expandRow(tree.component().getLeadSelectionRow() + 1);
+		// robot.waitForIdle();
+
+		// sleep(2);
+	}
+
+	public void sleep(int seconds) {
+		try {
+			Thread.sleep(seconds * 1000, 0);
+		} catch (InterruptedException e) {
+			e.printStackTrace();
+		}
+	}
+
+	@AfterClass
+	public void tearDown() {
+		// frame.close();
+		frame.cleanUp();
+	}
+
+}
Index: java/main/src/test/java/com/framsticks/parsers/F0ParserTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/parsers/F0ParserTest.java	(revision 79)
+++ java/main/src/test/java/com/framsticks/parsers/F0ParserTest.java	(revision 84)
@@ -1,74 +1,104 @@
 package com.framsticks.parsers;
 
+import org.testng.annotations.*;
 import com.framsticks.model.*;
 import com.framsticks.model.Package;
 import com.framsticks.params.*;
 import com.framsticks.params.types.FloatParam;
-import com.framsticks.util.Point3d;
-import org.apache.log4j.PropertyConfigurator;
-import org.junit.Test;
+import com.framsticks.test.TestConfiguration;
+import com.framsticks.util.math.Point3d;
 
+import java.io.IOException;
+import java.text.ParseException;
 import java.util.List;
-
-import static org.junit.Assert.*;
+import static org.fest.assertions.Assertions.*;
+import static org.fest.assertions.Delta.*;
 
 /**
  * Author: Piotr Śniegowski
  */
-public class F0ParserTest {
+public class F0ParserTest extends TestConfiguration {
+
+	private Schema schema;
+	private List<AccessInterface> accesses;
+	private List<Object> objects;
+	private Model model;
+
+	@BeforeClass
+	public void setUp() throws Exception {
+		schema = new Schema(Schema.getDefaultDefinitionAsStream());
+		Package.register(schema.getRegistry());
+	}
 
 	@Test
-	public void testParser() throws Exception {
-		PropertyConfigurator.configure(getClass().getResource("/log4j.properties"));
-		//testing schema
-		Schema schema = new Schema(Schema.getDefaultDefinitionAsStream());
+	public void primitiveParam() {
+		FramsClass joint = schema.getRegistry().getInfoFromCache("j");
+		PrimitiveParam dx = joint.getParamEntry("dx", PrimitiveParam.class);
+		assertThat(dx).isInstanceOf(FloatParam.class);
+		assertThat(schema.getNeuroClasses().size()).isEqualTo(21);
+		assertThat(dx.getName()).isEqualTo("delta.x");
+		assertThat(dx.getMin(Double.class)).isEqualTo(-2.0, delta(0.0));
+	}
 
-		{
-			FramsClass joint = schema.getRegistry().getInfoFromCache("j");
-			Param dx = joint.getParamEntry("dx");
-			assertEquals(FloatParam.class, dx.getClass());
-			assertEquals(21, schema.getNeuroClasses().size());
-			assertEquals("delta.x", dx.getName());
-			assertEquals(-2.0, dx.getMin(Double.class), 0.0);
-		}
+	@Test
+	public void readF0() throws IOException, ParseException {
+		accesses = new F0Parser(schema, F0ParserTest.class.getResourceAsStream("/parsers/f0_example.txt")).parse();
 
-		Package.register(schema.getRegistry());
-		//testing parser
-		List<AccessInterface> accesses = new F0Parser(schema, F0ParserTest.class.getResourceAsStream("/parsers/f0_example.txt")).parse();
+		assertThat(accesses.size()).isEqualTo(12);
+		assertThat(accesses.get(0).getSelected()).isInstanceOf(Model.class);
+		assertThat(accesses.get(5).get("i", String.class)).isEqualTo("1,2,3,\"dsadsa,,,,");
+		assertThat(accesses.get(7).get("d", String.class)).isEqualTo("|:p=0.25,r=1");
+		assertThat(accesses.get(10).get("d", String.class)).isEqualTo("@:p=0.25");
+	}
 
-		{
-			assertEquals(12, accesses.size());
-			assertTrue(accesses.get(0).getSelected() instanceof Model);
-			assertEquals("1,2,3,\"dsadsa,,,,", accesses.get(5).get("i", String.class));
-			assertEquals("|:p=0.25,r=1", accesses.get(7).get("d", String.class));
-			assertEquals("@:p=0.25", accesses.get(10).get("d", String.class));
-		}
+	@Test(dependsOnMethods = {"readF0"})
+	public void stripAccessInterface() {
+		objects = Util.stripAccessInterface(accesses);
 
-		List<Object> objects = Util.stripAccessInterface(accesses);
-		{
-			assertEquals(Part.class, objects.get(1).getClass());
-			assertEquals(Joint.class, objects.get(4).getClass());
-			assertEquals(NeuroDef.class, objects.get(6).getClass());
-		}
+		assertThat(objects.get(1)).isInstanceOf(Part.class);
+		assertThat(objects.get(4)).isInstanceOf(Joint.class);
+		assertThat(objects.get(6)).isInstanceOf(NeuroDef.class);
+	}
 
-		Model model = Model.build(objects);
-		{
-			assertEquals(3, model.getParts().size());
-			assertEquals(6, model.getNeuroDefs().size());
-			assertEquals(2, model.getJoints().size());
+	@Test(dependsOnMethods = {"stripAccessInterface"})
+	public void buildModel() {
+		model = Model.build(objects);
 
-			assertEquals(new Integer(0), model.getJoints().get(0).part1);
-			assertEquals(new Integer(1), model.getJoints().get(0).part2);
-			assertEquals(new Integer(1), model.getNeuroDefs().get(0).part);
-			assertEquals(new Integer(-1), model.getNeuroDefs().get(0).joint);
-			assertEquals("|:p=0.25,r=1", model.getNeuroDefs().get(1).details);
-			assertEquals("N", model.getNeuroDefs().get(3).details);
-			assertEquals(new Integer(-1), model.getNeuroDefs().get(4).part);
+		assertThat(model.getParts().size()).isEqualTo(3);
+		assertThat(model.getNeuroDefs().size()).isEqualTo(6);
+		assertThat(model.getJoints().size()).isEqualTo(2);
 
-			assertEquals(2.0, model.getParts().get(1).getPosition().x, 0.0);
-			assertTrue(model.getParts().get(2).getPosition().sub(new Point3d(2.27236, -0.0792596, -0.958924)).length() < 0.0001);
-			assertTrue(model.getParts().get(2).getOrientation().y.sub(new Point3d(0.870277, -0.404792, 0.280644)).length() < 0.0001);
-		}
+		assertThat(model.getJoints().get(0).part1).isEqualTo(0);
+		assertThat(model.getJoints().get(0).part2).isEqualTo(1);
+		assertThat(model.getNeuroDefs().get(0).part).isEqualTo(1);
+		assertThat(model.getNeuroDefs().get(0).joint).isEqualTo(-1);
+		assertThat(model.getNeuroDefs().get(1).details).isEqualTo("|:p=0.25,r=1");
+		assertThat(model.getNeuroDefs().get(3).details).isEqualTo("N");
+		assertThat(model.getNeuroDefs().get(4).part).isEqualTo(-1);
 
+		assertThat(model.getParts().get(1).getPosition().x).isEqualTo(2.0, delta(0.0));
+		assertThat(model.getParts().get(2).getPosition().sub(new Point3d(2.27236, -0.0792596, -0.958924)).length()).isLessThan(0.0001);
+		assertThat(model.getParts().get(2).getOrientation().y.sub(new Point3d(0.870277, -0.404792, 0.280644)).length()).isLessThan(0.0001);
+	}
+
+	@Test(dependsOnMethods = {"buildModel"})
+	public void print() throws Exception {
+		ListSink sink = new ListSink();
+		new F0Writer(schema, model, sink).write();
+
+		assertThat(sink.getOut()).containsExactly(
+			"p:",
+			"p:2.0,i=,Vstyle=",
+			"p:2.272364001928095,-0.07925961087140347,-0.9589242746631385,i=bla",
+			"j:0,1,dx=2.0",
+			"j:1,2,rx=8.0,5.0,6.0,dx=1.0,i=\"1,2,3,\\\"dsadsa,,,,\"",
+			"n:p=1",
+			"n:j=0,d=\"|:p=0.25,r=1\"",
+			"n:j=0,d=G",
+			"n:p=1",
+			"n:j=0,d=@:p=0.25",
+			"n:p=1,d=Nu",
+			"m:"
+		);
 
 	}
Index: java/main/src/test/java/com/framsticks/test/TestConfiguration.java
===================================================================
--- java/main/src/test/java/com/framsticks/test/TestConfiguration.java	(revision 84)
+++ java/main/src/test/java/com/framsticks/test/TestConfiguration.java	(revision 84)
@@ -0,0 +1,18 @@
+package com.framsticks.test;
+
+import org.apache.log4j.Logger;
+import org.apache.log4j.PropertyConfigurator;
+import org.testng.annotations.*;
+
+public class TestConfiguration {
+
+	private static final Logger log =
+		Logger.getLogger(TestConfiguration.class);
+
+	@BeforeClass
+	public static void setUpConfiguration() {
+		PropertyConfigurator.configure(TestConfiguration.class.getResource("/log4j.properties"));
+		log.info("logging configured");
+	}
+
+}
